Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4901)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1)
@@ -807,64 +222,33 @@
 !--       Exchange of ghost points (lateral boundary conditions)
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'start' )
-
-          CALL module_interface_exchange_horiz( 'after_prognostic_equation' )
+          CALL exchange_horiz( u_p, uxrp,    0 )
+          CALL exchange_horiz( v_p,    0, vynp )
+          CALL exchange_horiz( w_p,    0,    0 )
+          CALL exchange_horiz( pt_p,   0,    0 )
+          IF ( .NOT. constant_diffusion       )  CALL exchange_horiz( e_p, 0, 0)
+          IF ( moisture  .OR.  passive_scalar )  CALL exchange_horiz( q_p, 0, 0)
+          IF ( cloud_droplets )  THEN
+             CALL exchange_horiz( ql,    0, 0 )
+             CALL exchange_horiz( ql_c,  0, 0 )
+             CALL exchange_horiz( ql_v,  0, 0 )
+             CALL exchange_horiz( ql_vp, 0, 0 )
+          ENDIF
 
           CALL cpu_log( log_point(26), 'exchange-horiz-progn', 'stop' )
 
 !
+!--       Apply time filter in case of leap-frog timestep
+          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
+             CALL asselin_filter
+          ENDIF
+
+!
+!--       Swap the time levels in preparation for the next time step.
+          CALL swap_timelevel
+
+!
 !--       Boundary conditions for the prognostic quantities (except of the
-!--       velocities at the outflow in case of a non-cyclic lateral wall) and
-!--       boundary conditions for module-specific variables
-          CALL module_interface_boundary_conditions
-
-!
-!--       Incrementing timestep counter
-          timestep_count = timestep_count + 1
-
-          CALL cpu_log( log_point(28), 'swap_timelevel', 'start' )
-!
-!--       Set the swap level for all modules
-          CALL module_interface_swap_timelevel( MOD( timestep_count, 2) )
-
-#if defined( __parallel )
-!
-!--       Set the swap level for steering the pmc data transfer
-          IF ( nested_run )  CALL pmci_set_swaplevel( MOD( timestep_count, 2) + 1 )  !> @todo: why the +1 ?
-#endif
-
-          CALL cpu_log( log_point(28), 'swap_timelevel', 'stop' )
-
-#if defined( __parallel )
-          IF ( nested_run )  THEN
-
-             CALL cpu_log( log_point(60), 'nesting', 'start' )
-!
-!--          Domain nesting. The data transfer subroutines pmci_parent_datatrans
-!--          and pmci_child_datatrans are called inside the wrapper
-!--          subroutine pmci_datatrans according to the control parameters
-!--          nesting_mode and nesting_datatransfer_mode.
-!--          TO_DO: why is nesting_mode given as a parameter here?
-             CALL pmci_datatrans( nesting_mode )
-
-             IF ( TRIM( nesting_mode ) == 'two-way' .OR.  nesting_mode == 'vertical' )  THEN
-
-                CALL cpu_log( log_point_s(92), 'exchange-horiz-nest', 'start' )
-!
-!--             Exchange_horiz is needed for all parent-domains after the
-!--             anterpolation
-                CALL module_interface_exchange_horiz( 'after_anterpolation' )
-
-                CALL cpu_log( log_point_s(92), 'exchange-horiz-nest', 'stop' )
-
-             ENDIF
-
-!
-!--          Set boundary conditions again after interpolation and anterpolation.
-             CALL pmci_boundary_conds
-
-             CALL cpu_log( log_point(60), 'nesting', 'stop' )
-
-          ENDIF
-#endif
+!--       velocities at the outflow in case of a non-cyclic lateral wall)
+          CALL boundary_conds( 'main' )
 
 !
@@ -872,43 +256,25 @@
 !--       when a sloping surface is used
           IF ( sloping_surface )  THEN
-             IF ( nxl ==  0 )  pt(:,:,nxlg:nxl-1) = pt(:,:,nxlg:nxl-1) - pt_slope_offset
-             IF ( nxr == nx )  pt(:,:,nxr+1:nxrg) = pt(:,:,nxr+1:nxrg) + pt_slope_offset
-          ENDIF
-
-!
-!--       Increase temperature pt(0) according to pt_surface_heating_rate (convert from K/h to K/s)
-          IF ( pt_surface_heating_rate /= 0.0_wp .AND. intermediate_timestep_count == 1 ) THEN
-             pt(0,:,:) = pt(0,:,:) + dt_3d * pt_surface_heating_rate / 3600.0_wp
-          ENDIF
-
-!
-!--       Impose a turbulent inflow using the recycling method
-          IF ( turbulent_inflow )  CALL inflow_turbulence
-
-!
-!--       Set values at outflow boundary using the special outflow condition
-          IF ( turbulent_outflow )  CALL outflow_turbulence
+             IF ( nxl ==  0 )  pt(:,:,nxl-1) = pt(:,:,nxl-1) - pt_slope_offset
+             IF ( nxr == nx )  pt(:,:,nxr+1) = pt(:,:,nxr+1) + pt_slope_offset
+          ENDIF
 
 !
 !--       Impose a random perturbation on the horizontal velocity field
-          IF ( create_disturbances  .AND.  ( call_psolver_at_all_substeps  .AND.                   &
-               intermediate_timestep_count == intermediate_timestep_count_max )                    &
-               .OR. ( .NOT. call_psolver_at_all_substeps  .AND.  intermediate_timestep_count == 1 ) ) &
+          IF ( create_disturbances  .AND.  &
+               intermediate_timestep_count == intermediate_timestep_count_max )&
           THEN
              time_disturb = time_disturb + dt_3d
              IF ( time_disturb >= dt_disturb )  THEN
-                IF ( disturbance_energy_limit /= 0.0_wp  .AND.                                     &
-                     hom(nzb+5,1,pr_palm,0) < disturbance_energy_limit )  THEN
-                   CALL disturb_field( 'u', tend, u )
-                   CALL disturb_field( 'v', tend, v )
-                ELSEIF ( ( .NOT. bc_lr_cyc  .OR.  .NOT. bc_ns_cyc )                                &
-                         .AND. .NOT. child_domain  .AND.  .NOT.  nesting_offline )                 &
-                THEN
+                IF ( hom(nzb+5,1,var_hom,0) < disturbance_energy_limit )  THEN
+                   CALL disturb_field( nzb_u_inner, tend, u, uxrp, 0    )
+                   CALL disturb_field( nzb_v_inner, tend, v ,   0, vynp )
+                ELSEIF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  THEN
 !
 !--                Runs with a non-cyclic lateral wall need perturbations
 !--                near the inflow throughout the whole simulation
                    dist_range = 1
-                   CALL disturb_field( 'u', tend, u )
-                   CALL disturb_field( 'v', tend, v )
+                   CALL disturb_field( nzb_u_inner, tend, u, uxrp, 0    )
+                   CALL disturb_field( nzb_v_inner, tend, v ,   0, vynp )
                    dist_range = 0
                 ENDIF
@@ -918,68 +284,25 @@
 
 !
-!--       Map forcing data derived from larger scale model onto domain
-!--       boundaries. Further, update geostrophic wind components.
-          IF ( nesting_offline  .AND.  intermediate_timestep_count ==                              &
-                                       intermediate_timestep_count_max  )  THEN
-!--          Determine interpolation factor before boundary conditions and geostrophic wind
-!--          is updated.
-             CALL nesting_offl_interpolation_factor
-             CALL nesting_offl_bc
-!              CALL nesting_offl_geostrophic_wind
-          ENDIF
-!
-!--       Impose a turbulent inflow using synthetic generated turbulence.
-          IF ( syn_turb_gen  .AND.                                                                 &
-               intermediate_timestep_count == intermediate_timestep_count_max )  THEN
-             CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
-             CALL stg_main
-             CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
-          ENDIF
-!
-!--       Ensure mass conservation. This need to be done after imposing
-!--       synthetic turbulence and top boundary condition for pressure is set to
-!--       Neumann conditions.
-!--       Is this also required in case of Dirichlet?
-          IF ( nesting_offline )  CALL nesting_offl_mass_conservation
-!
 !--       Reduce the velocity divergence via the equation for perturbation
 !--       pressure.
-          IF ( intermediate_timestep_count == 1  .OR.  call_psolver_at_all_substeps )  THEN
-
-#if defined( __parallel )
-!
-!--          Mass (volume) flux correction to ensure global mass conservation for child domains.
-             IF ( child_domain )  THEN
-                IF ( nesting_mode == 'vertical' )  THEN
-                   CALL pmci_ensure_nest_mass_conservation_vertical
-                ELSE
-                   CALL pmci_ensure_nest_mass_conservation
-                ENDIF
-             ENDIF
-#endif
+          IF ( intermediate_timestep_count == intermediate_timestep_count_max &
+               .OR.  call_psolver_at_all_substeps )  THEN
              CALL pres
-
-          ENDIF
-!
-!--       Particle transport/physics with the Lagrangian particle model
-!--       (only once during intermediate steps, because it uses an Euler-step)
-!--       ### particle model should be moved before prognostic_equations, in order
-!--       to regard droplet interactions directly
-
-          CALL module_interface_actions( 'after_pressure_solver' )
-!
-!--       Interaction of droplets with temperature and mixing ratio.
-!--       Droplet condensation and evaporation is calculated within
-!--       advec_particles.
+          ENDIF
+
+!
+!--       In case of a non-cyclic lateral wall, set the boundary conditions for
+!--       the velocities at the outflow
+          IF ( bc_lr /= 'cyclic'  .OR.  bc_ns /= 'cyclic' )  THEN
+             CALL boundary_conds( 'outflow_uvw' )
+          ENDIF
+
+!
+!--       If required, compute virtuell potential temperature
+          IF ( moisture ) CALL compute_vpt
+
 !
 !--       If required, compute liquid water content
-          IF ( bulk_cloud_model )  THEN
-             CALL calc_liquid_water_content
-          ENDIF
-!
-!--       If required, compute virtual potential temperature
-          IF ( humidity )  THEN
-             CALL compute_vpt
-          ENDIF
+          IF ( cloud_physics ) CALL calc_liquid_water_content
 
 !
@@ -988,64 +311,18 @@
 
 !
-!--          Determine surface fluxes shf and qsws and surface values
-!--          pt_surface and q_surface in dependence on data from external
-!--          file LSF_DATA respectively
-             IF ( ( large_scale_forcing .AND. lsf_surf ) .AND.                                     &
-                 intermediate_timestep_count == intermediate_timestep_count_max )                  &
-             THEN
-                CALL ls_forcing_surf( simulated_time )
+!--          First the vertical fluxes in the Prandtl layer are being computed
+             IF ( prandtl_layer )  THEN
+                CALL cpu_log( log_point(19), 'prandtl_fluxes', 'start' )
+                CALL prandtl_fluxes
+                CALL cpu_log( log_point(19), 'prandtl_fluxes', 'stop' )
              ENDIF
 
-!
-!--          First the vertical (and horizontal) fluxes in the surface
-!--          (constant flux) layer are computed
-             IF ( constant_flux_layer )  THEN
-                CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'start' )
-                CALL surface_layer_fluxes
-                CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'stop' )
-             ENDIF
-!
-!--          If required, solve the energy balance for the surface and run soil
-!--          model. Call for horizontal as well as vertical surfaces
-             IF ( land_surface .AND. time_since_reference_point >= skip_time_do_lsm)  THEN
-
-                CALL cpu_log( log_point(54), 'land_surface', 'start' )
-                CALL lsm_energy_balance( .FALSE. )
-
-!
-!--             At the end, set boundary conditons for potential temperature
-!--             and humidity after running the land-surface model. This
-!--             might be important for the nesting, where arrays are transfered.
-                CALL lsm_boundary_condition
-
-
-                CALL cpu_log( log_point(54), 'land_surface', 'stop' )
-             ENDIF
-!
-!--          If required, solve the energy balance for urban surfaces and run
-!--          the material heat model
-             IF (urban_surface) THEN
-                CALL cpu_log( log_point(74), 'urban_surface', 'start' )
-                CALL usm_energy_balance( .FALSE. )
-
-!
-!--             At the end, set boundary conditons for potential temperature
-!--             and humidity after running the urban-surface model. This
-!--             might be important for the nesting, where arrays are transfered.
-                CALL usm_boundary_condition
-
-                CALL cpu_log( log_point(74), 'urban_surface', 'stop' )
-             ENDIF
 !
 !--          Compute the diffusion coefficients
              CALL cpu_log( log_point(17), 'diffusivities', 'start' )
-             IF ( .NOT. humidity ) THEN
-                IF ( ocean_mode )  THEN
-                   CALL tcm_diffusivities( prho, prho_reference )
-                ELSE
-                   CALL tcm_diffusivities( pt, pt_reference )
-                ENDIF
+             IF ( .NOT. moisture ) THEN
+                CALL diffusivities( pt )
              ELSE
-                CALL tcm_diffusivities( vpt, pt_reference )
+                CALL diffusivities( vpt )
              ENDIF
              CALL cpu_log( log_point(17), 'diffusivities', 'stop' )
@@ -1056,251 +333,40 @@
 
 !
-!--    Will be used at some point by flow_statistics.
-       !$ACC UPDATE &
-       !$ACC HOST(sums_l_l(nzb:nzt+1,0:statistic_regions,0)) &
-       !$ACC HOST(sums_us2_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsus_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_vs2_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsvs_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_ws2_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wspts_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wssas_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsqs_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsqcs_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsqis_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsqrs_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsncs_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsnis_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsnrs_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_wsss_ws_l(nzb:nzt+1,0)) &
-       !$ACC HOST(sums_salsa_ws_l(nzb:nzt+1,0))
-
-!
-!--    If required, calculate radiative fluxes and heating rates
-       IF ( radiation  .AND.  time_since_reference_point >= skip_time_do_radiation )  THEN
-
-          time_radiation = time_radiation + dt_3d
-
-          IF ( time_radiation >= dt_radiation  .OR.  force_radiation_call )  THEN
-
-             CALL cpu_log( log_point(50), 'radiation', 'start' )
-
-             IF ( time_radiation >= dt_radiation )  THEN
-                time_radiation = time_radiation - dt_radiation
-             ENDIF
-
-!
-!--          Adjust the current time to the time step of the radiation model.
-!--          Needed since radiation is pre-calculated and stored only on apparent
-!--          solar positions
-             time_since_reference_point_save = time_since_reference_point
-             time_since_reference_point = time_since_reference_point -                            &
-                                          MODULO(time_since_reference_point, dt_radiation)
-
-             CALL radiation_control
-
-             IF ( ( urban_surface  .OR.  land_surface )  .AND.  radiation_interactions )  THEN
-                CALL cpu_log( log_point_s(46), 'radiation_interaction', 'start' )
-                CALL radiation_interaction
-                CALL cpu_log( log_point_s(46), 'radiation_interaction', 'stop' )
-             ENDIF
-
-!
-!--          Return the current time to its original value
-             time_since_reference_point = time_since_reference_point_save
-!
-!--          Reset forcing of radiation call
-             force_radiation_call = .FALSE.
-
-             CALL cpu_log( log_point(50), 'radiation', 'stop' )
-
-          ENDIF
-       ENDIF
-
-
-!
-!-- 20200203 (ECC)
-!-- allows for emission update mode in legacy mode as well as on-demand mode
-!-- note that under on-demand mode emission update is no longer restricted to
-!-- an hourly frequency, but whenever the simulation time corresponds to an
-!-- inrement in emission timestamp value
-
-!
-!-- If required, consider chemical emissions
-
-       IF  ( air_chemistry .AND. emissions_anthropogenic )  THEN
-
-          IF  ( emiss_read_legacy_mode )  THEN
-!
-!-- get hourly index and updates emission data when the hour is passed
-
-             CALL get_date_time( time_since_reference_point, hour=hour )
-
-             IF  ( hour_call_emis /= hour )   THEN
-
-                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
-                hour_call_emis = hour
-
-             ENDIF
-
-          ELSE
-
-             CALL chem_emissions_update_on_demand
-
-          ENDIF
-
-       ENDIF
-
-
-!
-!--    If required, consider aerosol emissions for the salsa model
-       IF ( salsa )  THEN
-!
-!--       Call emission routine to update emissions if needed
-          CALL salsa_emission_update
-
-       ENDIF
-!
-!--    If required, calculate indoor temperature, waste heat, heat flux
-!--    through wall, etc.
-!--    dt_indoor steers the frequency of the indoor model calculations.
-!--    Note, at first timestep indoor model is called, in order to provide
-!--    a waste heat flux.
-       IF ( indoor_model )  THEN
-
-          time_indoor = time_indoor + dt_3d
-
-          IF ( time_indoor >= dt_indoor  .OR.  current_timestep_number == 0 )  THEN
-
-             IF ( time_indoor >= dt_indoor )  time_indoor = time_indoor - dt_indoor
-
-             CALL cpu_log( log_point(76), 'indoor_model', 'start' )
-             CALL im_main_heatcool
-             CALL cpu_log( log_point(76), 'indoor_model', 'stop' )
-
-          ENDIF
-       ENDIF
+!--    Execute user-defined actions
+       CALL user_actions( 'after_integration' )
+
 !
 !--    Increase simulation time and output times
-       nr_timesteps_this_run      = nr_timesteps_this_run + 1
-       current_timestep_number    = current_timestep_number + 1
-       simulated_time             = simulated_time   + dt_3d
-       time_since_reference_point = simulated_time - coupling_start_time
-       simulated_time_chr         = time_to_string( time_since_reference_point )
-
-
-       IF ( time_since_reference_point >= skip_time_data_output_av )  THEN
+       current_timestep_number = current_timestep_number + 1
+       simulated_time     = simulated_time   + dt_3d
+       simulated_time_chr = time_to_string( simulated_time )
+       IF ( simulated_time >= skip_time_data_output_av )  THEN
           time_do_av         = time_do_av       + dt_3d
        ENDIF
-       IF ( time_since_reference_point >= skip_time_do2d_xy )  THEN
+       IF ( simulated_time >= skip_time_do2d_xy )  THEN
           time_do2d_xy       = time_do2d_xy     + dt_3d
        ENDIF
-       IF ( time_since_reference_point >= skip_time_do2d_xz )  THEN
+       IF ( simulated_time >= skip_time_do2d_xz )  THEN
           time_do2d_xz       = time_do2d_xz     + dt_3d
        ENDIF
-       IF ( time_since_reference_point >= skip_time_do2d_yz )  THEN
+       IF ( simulated_time >= skip_time_do2d_yz )  THEN
           time_do2d_yz       = time_do2d_yz     + dt_3d
        ENDIF
-       IF ( time_since_reference_point >= skip_time_do3d    )  THEN
+       IF ( simulated_time >= skip_time_do3d    )  THEN
           time_do3d          = time_do3d        + dt_3d
        ENDIF
-       DO  mid = 1, masks
-          IF ( time_since_reference_point >= skip_time_domask(mid) )  THEN
-             time_domask(mid)= time_domask(mid) + dt_3d
-          ENDIF
-       ENDDO
-       IF ( time_since_reference_point >= skip_time_dosp )  THEN
+       time_dvrp          = time_dvrp        + dt_3d
+       IF ( simulated_time >= skip_time_dosp )  THEN
           time_dosp       = time_dosp        + dt_3d
        ENDIF
        time_dots          = time_dots        + dt_3d
-       IF ( .NOT. first_call_lpm )  THEN
+       IF ( .NOT. first_call_advec_particles )  THEN
           time_dopts      = time_dopts       + dt_3d
        ENDIF
-       IF ( time_since_reference_point >= skip_time_dopr )  THEN
+       IF ( simulated_time >= skip_time_dopr )  THEN
           time_dopr       = time_dopr        + dt_3d
        ENDIF
-       time_dopr_listing  = time_dopr_listing + dt_3d
+       time_dopr_listing          = time_dopr_listing        + dt_3d
        time_run_control   = time_run_control + dt_3d
-!
-!--    Increment time-counter for surface output
-       IF ( surface_output )  THEN
-          IF ( time_since_reference_point >= skip_time_dosurf )  THEN
-             time_dosurf    = time_dosurf + dt_3d
-          ENDIF
-          IF ( time_since_reference_point >= skip_time_dosurf_av )  THEN
-             time_dosurf_av = time_dosurf_av + dt_3d
-          ENDIF
-       ENDIF
-!
-!--    Increment time-counter for virtual measurements
-       IF ( virtual_measurement  .AND.  vm_time_start <= time_since_reference_point )  THEN
-          time_virtual_measurement = time_virtual_measurement + dt_3d
-       ENDIF
-
-!
-!--    Increment time-counter for wind turbine data output
-       IF ( wind_turbine )  THEN
-          time_wtm = time_wtm + dt_3d
-       ENDIF
-
-!
-!--    In case of synthetic turbulence generation and parametrized turbulence
-!--    information, update the time counter and if required, adjust the
-!--    STG to new atmospheric conditions.
-       IF ( syn_turb_gen  )  THEN
-          IF ( parametrize_inflow_turbulence )  THEN
-             time_stg_adjust = time_stg_adjust + dt_3d
-             IF ( time_stg_adjust >= dt_stg_adjust )  THEN
-                CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
-                CALL stg_adjust
-                CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
-             ENDIF
-          ENDIF
-          time_stg_call = time_stg_call + dt_3d
-       ENDIF
-
-!
-!--    Data exchange between coupled models
-       IF ( coupling_mode /= 'uncoupled'  .AND.  run_coupled )  THEN
-          time_coupling = time_coupling + dt_3d
-
-!
-!--       In case of model termination initiated by the local model
-!--       (terminate_coupled > 0), the coupler must be skipped because it would
-!--       cause an MPI intercomminucation hang.
-!--       If necessary, the coupler will be called at the beginning of the
-!--       next restart run.
-          DO WHILE ( time_coupling >= dt_coupling  .AND.  terminate_coupled == 0 )
-             CALL surface_coupler
-             time_coupling = time_coupling - dt_coupling
-          ENDDO
-       ENDIF
-
-!
-!--    Biometeorology calculation of stationary thermal indices
-!--    Todo (kanani): biometeorology needs own time_... treatment.
-!--                   It might be that time_do2d_xy differs from time_do3d,
-!--                   and then we might get trouble with the biomet output,
-!--                   because we can have 2d and/or 3d biomet output!!
-       IF ( biometeorology                                                                         &
-            .AND. ( ( time_do3d >= dt_do3d  .AND.  time_since_reference_point >= skip_time_do3d )  &
-                  .OR.                                                                             &
-            ( time_do2d_xy >= dt_do2d_xy  .AND.  time_since_reference_point >= skip_time_do2d_xy ) &
-                    ) )  THEN
-!
-!--       If required, do thermal comfort calculations
-          IF ( thermal_comfort )  THEN
-             CALL bio_calculate_thermal_index_maps ( .FALSE. )
-          ENDIF
-!
-!--       If required, do UV exposure calculations
-          IF ( uv_exposure )  THEN
-             CALL bio_calculate_uv_exposure
-          ENDIF
-       ENDIF
-
-!
-!--    Execute alle other module actions routunes
-       CALL module_interface_actions( 'after_integration' )
 
 !
@@ -1315,6 +381,5 @@
 !--    Check, if restart is necessary (because cpu-time is expiring or
 !--    because it is forced by user) and set stop flag
-!--    This call is skipped if the remote model has already initiated a restart.
-       IF ( .NOT. terminate_run )  CALL check_for_restart
+       CALL check_for_restart
 
 !
@@ -1331,11 +396,12 @@
 !
 !--    If required, call flow_statistics for averaging in time
-       IF ( averaging_interval_pr /= 0.0_wp  .AND.                                                 &
-            ( dt_dopr - time_dopr ) <= averaging_interval_pr  .AND.                                &
-            time_since_reference_point >= skip_time_dopr )  THEN
+       IF ( averaging_interval_pr /= 0.0  .AND.  &
+            ( dt_dopr - time_dopr ) <= averaging_interval_pr  .AND.  &
+            simulated_time >= skip_time_dopr )  THEN
           time_dopr_av = time_dopr_av + dt_3d
           IF ( time_dopr_av >= dt_averaging_input_pr )  THEN
              do_sum = .TRUE.
-             time_dopr_av = MOD( time_dopr_av, MAX( dt_averaging_input_pr, dt_3d ) )
+             time_dopr_av = MOD( time_dopr_av, &
+                                    MAX( dt_averaging_input_pr, dt_3d ) )
           ENDIF
        ENDIF
@@ -1343,14 +409,11 @@
 
 !
-!--    Sum-up 3d-arrays for later output of time-averaged 2d/3d/masked data
-       IF ( averaging_interval /= 0.0_wp  .AND.                                                    &
-            ( dt_data_output_av - time_do_av ) <= averaging_interval  .AND.                        &
-            time_since_reference_point >= skip_time_data_output_av )                               &
+!--    Sum-up 3d-arrays for later output of time-averaged data
+       IF ( averaging_interval /= 0.0  .AND.                                &
+            ( dt_data_output_av - time_do_av ) <= averaging_interval  .AND. &
+            simulated_time >= skip_time_data_output_av )                    &
        THEN
           time_do_sla = time_do_sla + dt_3d
           IF ( time_do_sla >= dt_averaging_input )  THEN
-             IF ( current_timestep_number > timestep_number_at_prev_calc )                         &
-                CALL doq_calculate
-
              CALL sum_up_3d_data
              average_count_3d = average_count_3d + 1
@@ -1358,49 +421,31 @@
           ENDIF
        ENDIF
-!
-!--    Average surface data
-       IF ( surface_output )  THEN
-          IF ( averaging_interval_surf /= 0.0_wp                                                   &
-                .AND.  ( dt_dosurf_av - time_dosurf_av ) <= averaging_interval_surf                &
-                .AND.  time_since_reference_point >= skip_time_dosurf_av )  THEN
-             IF ( time_dosurf_av >= dt_averaging_input )  THEN
-                CALL surface_data_output_averaging
-                average_count_surf = average_count_surf + 1
-             ENDIF
-          ENDIF
-       ENDIF
 
 !
 !--    Calculate spectra for time averaging
-       IF ( averaging_interval_sp /= 0.0_wp  .AND. ( dt_dosp - time_dosp ) <= averaging_interval_sp&
-            .AND.  time_since_reference_point >= skip_time_dosp )  THEN
+       IF ( averaging_interval_sp /= 0.0  .AND.  &
+            ( dt_dosp - time_dosp ) <= averaging_interval_sp  .AND.  &
+            simulated_time >= skip_time_dosp )  THEN
           time_dosp_av = time_dosp_av + dt_3d
           IF ( time_dosp_av >= dt_averaging_input_pr )  THEN
              CALL calc_spectra
-             time_dosp_av = MOD( time_dosp_av, MAX( dt_averaging_input_pr, dt_3d ) )
-          ENDIF
-       ENDIF
-
-!
-!--    Call flight module and output data
-       IF ( virtual_flight )  THEN
-          CALL flight_measurement
-          CALL data_output_flight
-       ENDIF
-!
-!--    Take virtual measurements
-       IF ( virtual_measurement  .AND.  time_virtual_measurement >= dt_virtual_measurement         &
-                                 .AND.  vm_time_start <= time_since_reference_point )  THEN
-          CALL vm_sampling
-          CALL vm_data_output
-          time_virtual_measurement = MOD(      time_virtual_measurement,                           &
-                                          MAX( dt_virtual_measurement, dt_3d ) )
-       ENDIF
-
-!
-!--    Output wind turbine data
-       IF ( wind_turbine  .AND.  time_wtm >= dt_data_output_wtm )  THEN
-          CALL wtm_data_output
-          time_wtm = MOD( time_wtm, MAX( dt_data_output_wtm, dt_3d ) )
+             time_dosp_av = MOD( time_dosp_av, &
+                                 MAX( dt_averaging_input_pr, dt_3d ) )
+          ENDIF
+       ENDIF
+
+!
+!--    Computation and output of run control parameters.
+!--    This is also done whenever the time step has changed or perturbations
+!--    have been imposed
+       IF ( time_run_control >= dt_run_control  .OR.                     &
+            ( dt_changed  .AND.  timestep_scheme(1:5) /= 'runge' )  .OR. &
+            disturbance_created )                                        &
+       THEN
+          CALL run_control
+          IF ( time_run_control >= dt_run_control )  THEN
+             time_run_control = MOD( time_run_control, &
+                                     MAX( dt_run_control, dt_3d ) )
+          ENDIF
        ENDIF
 
@@ -1409,13 +454,14 @@
        IF ( time_dopr_listing >= dt_dopr_listing )  THEN
           CALL print_1d
-          time_dopr_listing = MOD( time_dopr_listing, MAX( dt_dopr_listing, dt_3d ) )
+          time_dopr_listing = MOD( time_dopr_listing, MAX( dt_dopr_listing, &
+                                                           dt_3d ) )
        ENDIF
 
 !
 !--    Graphic output for PROFIL
-       IF ( time_dopr >= dt_dopr  .AND.  time_since_reference_point >= skip_time_dopr )  THEN
+       IF ( time_dopr >= dt_dopr )  THEN
           IF ( dopr_n /= 0 )  CALL data_output_profiles
           time_dopr = MOD( time_dopr, MAX( dt_dopr, dt_3d ) )
-          time_dopr_av = 0.0_wp    ! due to averaging (see above)
+          time_dopr_av = 0.0    ! due to averaging (see above)
        ENDIF
 
@@ -1423,5 +469,5 @@
 !--    Graphic output for time series
        IF ( time_dots >= dt_dots )  THEN
-          CALL data_output_tseries
+          IF ( dots_n /= 0 )  CALL data_output_tseries
           time_dots = MOD( time_dots, MAX( dt_dots, dt_3d ) )
        ENDIF
@@ -1430,5 +476,5 @@
 !--    Output of spectra (formatted for use with PROFIL), in case of no
 !--    time averaging, spectra has to be calculated before
-       IF ( time_dosp >= dt_dosp  .AND.  time_since_reference_point >= skip_time_dosp )  THEN
+       IF ( time_dosp >= dt_dosp )  THEN
           IF ( average_count_sp == 0 )  CALL calc_spectra
           CALL data_output_spectra
